;;;; AJL - generuj&testuj, v6
;;; (C) MM, 2009-2020

;;;; Zadanie: Vyriesit kryptogram    
;;;          s e n d
;;;          m o r e
;;;        ---------
;;;        m o n e y

;;;; Verzia 1 ******************************************************

(defvar *citac* -1)

(defun generuj ()
  (incf *citac*)
  (if (> *citac* 9999999)
      nil
      (list
       (mod (floor (/ *citac* 1000000)) 10)
       (mod (floor (/ *citac* 100000)) 10)
       (mod (floor (/ *citac* 10000)) 10)
       (mod (floor (/ *citac* 1000)) 10)
       (mod (floor (/ *citac* 100)) 10)
       (mod (floor (/ *citac* 10)) 10)
       (mod (floor (/ *citac* 1)) 10))))

(defun testuj (kandidat)
  (let ((y (first kandidat))
	(s (second kandidat))
	(e (third kandidat))
	(n (fourth kandidat))
	(d (fifth kandidat))
	(r (sixth kandidat))
	(o (seventh kandidat))
	(m 1))
    (and
     (not (= s e)) (not (= s n)) (not (= s d)) (not (= s m)) 
     (not (= s o)) (not (= s r)) (not (= s y)) (not (= e n)) 
     (not (= e d)) (not (= e m)) (not (= e o)) (not (= e r)) 
     (not (= e y)) (not (= n d)) (not (= n m)) (not (= n o)) 
     (not (= n r)) (not (= n y)) (not (= d m)) (not (= d o)) 
     (not (= d r)) (not (= d y)) (not (= m o)) (not (= m r)) 
     (not (= m y)) (not (= o r)) (not (= o y)) (not (= r y))
     ;; (not (= m 0))
     (not (= s 0))
     (= (+ (+ (* s 1000) (* e 100) (* n 10) d)
	   (+ (* m 1000) (* o 100) (* r 10) e))
	(+ (* m 10000) (* o 1000) (* n 100) (* e 10) y))
     (list 's s 'e e 'n n 'd d 'm m 'o o 'r r 'y y))))

(defun ries ()
  (setf *citac* -1)
  (do ((koniec nil))
      (koniec koniec)
    (let ((kandidat (generuj)))
      (if kandidat
	  (setf koniec (testuj kandidat))
	  (setf koniec :nema-riesenie)))))

;;;; Verzia 2 ******************************************************

(defun generuj ()
  (incf *citac*)
  (if (> *citac* 9999999)
      nil
      (mapcar #'(lambda (x) (mod (floor (/ *citac* x)) 10))
	      '(1000000 100000 10000 1000 100 10 1))))

(defun rozne-p (prvky)
  (cond ((> 2 (length prvky)) t)
	((= (first prvky) (second prvky)) nil)
	(t (rozne-p (rest prvky)))))

(defun testuj (kandidat &optional (poziadavka-roznosti t))
  (let ((y (first kandidat))
	(s (second kandidat))
	(e (third kandidat))
	(n (fourth kandidat))
	(d (fifth kandidat))
	(r (sixth kandidat))
	(o (seventh kandidat))
	(m 1))
    (and 
     (or (not poziadavka-roznosti)
	 (rozne-p (sort (list s e n d m o r y) #'<)))     
     ;;(not (= m 0))
     (not (= s 0))
     (let* ((v1 (mod (+ d e) 10)) 
	    (p1 (floor (/ (+ d e) 10))) 
	    (v2 (mod (+ p1 n r) 10)) 
	    (p2 (floor (/ (+ p1 n r) 10))) 
	    (v3 (mod (+ p2 e o) 10)) 
	    (p3 (floor (/ (+ p2 e o) 10))) 
	    (v4 (mod (+ p3 s m) 10)) 
	    (p4 (floor (/ (+ p3 s m) 10))) 
	    (v5 (mod (+ p4) 10)))
       (and(= v1 y) (= v2 e) (= v3 n) (= v4 o) (= v5 m)))
     (list 's s 'e e 'n n 'd d 'm m 'o o 'r r 'y y))))

;;;; Verzia 3 ******************************************************

(defun testuj (kandidat &optional (poziadavka-roznosti t))
  (let ((y (first kandidat))
	(s (second kandidat))
	(e (third kandidat))
	(n (fourth kandidat))
	(d (fifth kandidat))
	(r (sixth kandidat))
	(o (seventh kandidat))
	(m 1))
    (and
     (or (not poziadavka-roznosti)
	 (labels ((rozne-p (prvky)
		    (cond ((> 2 (length prvky)) t)
			  ((= (first prvky) (second prvky)) nil)
			  (t (rozne-p (rest prvky))))))
	   (rozne-p (sort (list s e n d m o r y) #'<))))     
     ;;(not (= m 0))
     (not (= s 0))
     (flet ((sucet-v-stlpci (prenos s1 s2)
	      (let ((x (+ prenos s1 s2)))
		(values (mod x 10) (floor (/ x 10))))))
       (let* ((v1) (p1) (v2) (p2) (v3) (p3) (v4) (p4) (v5))
	 (setf (values v1 p1) (sucet-v-stlpci 0 d e))
	 (setf (values v2 p2) (sucet-v-stlpci p1 n r))
	 (setf (values v3 p3) (sucet-v-stlpci p2 e o))
	 (setf (values v4 p4) (sucet-v-stlpci p3 s m))
	 (setf v5 (sucet-v-stlpci p4 0 0))
	 (and(= v1 y) (= v2 e) (= v3 n) (= v4 o) (= v5 m)))       
       )
     (list 's s 'e e 'n n 'd d 'm m 'o o 'r r 'y y))))

;;;; Verzia 4 ******************************************************

(defun testuj (kandidat &optional (poziadavka-roznosti t))
  (let ((y (first kandidat))
	(s (second kandidat))
	(e (third kandidat))
	(n (fourth kandidat))
	(d (fifth kandidat))
	(r (sixth kandidat))
	(o (seventh kandidat))
	(m 1))
    (and
     (or (not poziadavka-roznosti) (/= s e n d m o r y))     
     ;;(not (= m 0))
     (not (= s 0))
     (flet ((sucet-v-stlpci (prenos s1 s2)
	      (let ((x (+ prenos s1 s2)))
		(values (mod x 10) (floor (/ x 10))))))
       (multiple-value-bind (v1 p1) (sucet-v-stlpci 0 d e)
	 (multiple-value-bind (v2 p2) (sucet-v-stlpci p1 n r)
	   (multiple-value-bind (v3 p3) (sucet-v-stlpci p2 e o)
	     (multiple-value-bind (v4 p4) (sucet-v-stlpci p3 s m)
	       (and(= v1 y) (= v2 e) (= v3 n) (= v4 o) (= p4 m)))))))
     (list 's s 'e e 'n n 'd d 'm m 'o o 'r r 'y y))))

;;;; Verzia 5 ******************************************************

(defun generuj (&key ((:pocet-miest pm) 8))
  (incf *citac*)
  (unless (> *citac* (1- (expt 10 pm)))
      (mapcar #'(lambda (x) (mod (floor (/ *citac* x)) 10))
              (mapcar #'(lambda (x) (expt 10 (- x 1))) 
		      (maplist #'length (make-list pm))))))

(defun ries ()
  (setf *citac* -1)
  (do ((koniec nil))
      (koniec koniec)
    (let ((kandidat (generuj :pocet-miest 7)))
      (if kandidat
	  (setf koniec (testuj kandidat))
	  (setf koniec :nema-riesenie)))))

;;;; Verzia 6 ******************************************************

(defun generuj-citac (&key ((:pocet-miest pm) 8) (start 0))
  (let ((citac (- start 1)) 
	(maximum (- (expt 10 pm) 1))
	(zoznam-radov (mapcar #'(lambda (x) (expt 10 (- x 1))) 
			      (maplist #'length 
				       (make-list pm :initial-element 1)))))
    #'(lambda ()
	(incf citac)
	(unless (> citac maximum)
	    (mapcar #'(lambda (x) (mod (floor (/ citac x)) 10))
		    zoznam-radov)))))

(defun ries ()
  (let ((generuj (generuj-citac :pocet-miest 7)))
    (do ((koniec nil))
	(koniec koniec)
      (let ((kandidat (funcall generuj)))
	(if kandidat
	    (setf koniec (testuj kandidat))
	    (setf koniec :nema-riesenie))))))

;;;; Verzia 7 ******************************************************

(defun ries ()
  (let ((generuj (generuj-citac :pocet-miest 7)))
    (labels ((hladaj ()
	       (do ((kandidat (funcall generuj) (funcall generuj)))
		   ((not kandidat) '(:riesenie :nema))
		 (let ((riesenie (testuj kandidat)))
		   (when riesenie (return-from hladaj riesenie))))))
      (format t "~{~a:  ~a~%~}" (hladaj)))))

